unit mHauptfenster;
{**************************************************************************
  mHauptfenster.pas

  Die Oberflche fr den ChatClient.

  Diese Datei gehrt zu den Materialien zu dem Workshop
  "Zentralabitur: Kommunikation in Netzwerken" des 5. Informatiktag
  in Paderborn.
  Dieses Projekt ist im Frhjahr 2006 im Unterricht meines GK Informatik
  Jgst. 12 entwickelt und fr den Workshop nur leicht berarbeitet worden.
  Sie darf fr eigene Unterrichtszwecke frei verwendet werden.
  Eine anderweitige Verffentlichung ist nur mit meiner Erlaubnis zulssig.

  (c) Joachim Deckers, <joachim@deckers.name>, 03.04.2006
***************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mEtikett, mKnopf, mTextfeld, mZeilenbereich, mSuM,
  mChatClientVerbindung;

type
  THauptfenster = class(TForm)
    hatZbNachrichten: TZeilenbereich;
    hatTfServer: TTextfeld;
    hatTfPort: TTextfeld;
    hatKnVerbinde: TKnopf;
    hatKnSende: TKnopf;
    hatTfNachricht: TTextfeld;
    hatKnTrenne: TKnopf;
    hatEtServer: TEtikett;
    hatEtPort: TEtikett;
    hatTfUser: TTextfeld;
    Username: TEtikett;
    hatKnPrivat: TKnopf;
    hatTfName: TTextfeld;
    hatKnListe: TKnopf;
    procedure hatKnVerbindeGeklickt(Sender: TObject);
    procedure hatKnSendeGeklickt(Sender: TObject);
    procedure hatKnTrenneGeklickt(Sender: TObject);
    procedure hatKnPrivatGeklickt(Sender: TObject);
    procedure hatKnListeGeklickt(Sender: TObject);
  private
    { Private-Deklarationen }
    hatChatClientVerbindung: ChatClientVerbindung;
    procedure ausgabe(const pMeldung: Zeichenkette);
  public
    { Public-Deklarationen }

  end;

var
  Hauptfenster: THauptfenster;
  gesNachricht : Zeichenkette;
implementation

{$R *.dfm}

procedure THauptfenster.hatKnVerbindeGeklickt(Sender: TObject);
begin
  hatKnVerbinde.deaktiviere;
  hatKnTrenne.aktiviere;
  hatKnSende.aktiviere;
  hatKnListe.aktiviere;
  hatKnPrivat.aktiviere;

  hatChatClientVerbindung := ChatClientVerbindung.init(
    hatTfServer.inhaltalsText,
    hatTfPort.inhaltAlsGanzeZahl,
    hatZbNachrichten,
    hatTfUser.inhaltAlsText,
    self.ausgabe);
end;

procedure THauptfenster.hatKnSendeGeklickt(Sender: TObject);
begin
  hatChatClientVerbindung.sendeOeffentlich(hatTfNachricht.inhaltAlsText);
  hatTfNachricht.setzeInhalt('');
end;

procedure THauptfenster.hatKnPrivatGeklickt(Sender: TObject);
begin
  hatChatClientVerbindung.sendePrivat(hatTfNachricht.inhaltAlsText, hatTfName.inhaltAlsText);
  hatTfNachricht.setzeInhalt('');
end;

procedure THauptfenster.hatKnTrenneGeklickt(Sender: TObject);
begin
  hatKnTrenne.deaktiviere;
  hatChatClientVerbindung.meldeAb;
  hatChatClientVerbindung.gibFrei;
  hatKnVerbinde.aktiviere;
  hatKnSende.deaktiviere;
  hatKnListe.deaktiviere;
  hatKnPrivat.deaktiviere;
end;

procedure THauptfenster.hatKnListeGeklickt(Sender: TObject);
begin
  hatChatClientVerbindung.liste;
end;

procedure THauptfenster.ausgabe(const pMeldung: Zeichenkette);
begin
  hatZbNachrichten.haengeAn(pMeldung);
end;

end.
