unit mMailclient;

{******************************************************************
  mMailClient.pas

  Oberflche zum Abruf von E-Mails mittels der Klasse POP3Client.
  Diese Datei gehrt zu den Materialien zu dem Workshop
  "Zentralabitur: Kommunikation in Netzwerken" des 5. Informatiktag
  in Paderborn. Sie darf fr eigene Unterrichtszwecke frei verwendet
  werden. Eine anderweitige Verffentlichung ist nur mit meiner Erlaubnis
  zulssig.

  (c) Joachim Deckers, <joachim@deckers.name>, 03.04.2006
******************************************************************}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mZeilenbereich, mKnopf, mKennwortfeld, mTextfeld,
  mEtikett, mPOP3Client;

type
  TMailForm = class(TForm)
    hatEtikettServer: TEtikett;
    hatEtikettPort: TEtikett;
    hatEtikettUsername: TEtikett;
    hatEtikettKennwort: TEtikett;
    hatTextfeldServer: TTextfeld;
    hatTextfeldPort: TTextfeld;
    hatTextfeldUser: TTextfeld;
    hatKennwortfeldKennwort: TKennwortfeld;
    hatKnopfAnmelden: TKnopf;
    hatEtikettNachricht: TEtikett;
    hatTextfeldNr: TTextfeld;
    hatEtikettNachrichtVon: TEtikett;
    hatKnopfHolen: TKnopf;
    hatZeilenbereich: TZeilenbereich;
    hatKnopfAbmelden: TKnopf;
    hatKnopfBeenden: TKnopf;
    hatEtikettAnzahl: TEtikett;
    procedure hatKnopfAnmeldenGeklickt(Sender: TObject);
    procedure hatKnopfHolenGeklickt(Sender: TObject);
    procedure hatKnopfAbmeldenGeklickt(Sender: TObject);
    procedure hatKnopfBeendenGeklickt(Sender: TObject);
  private
    { Private-Deklarationen }
    hatPOP3Client: POP3Client;
  public
    { Public-Deklarationen }
  end;

var
  MailForm: TMailForm;

implementation

{$R *.dfm}

procedure TMailForm.hatKnopfAnmeldenGeklickt(Sender: TObject);
begin
  if hatPOP3Client = nil then
    hatPOP3Client := POP3Client.init;
  hatPOP3Client.anmelden(hatTextfeldServer.inhaltAlsText, hatTextfeldPort.inhaltAlsGanzeZahl,
    hatTextfeldUser.inhaltAlsText, hatKennwortfeldKennwort.inhaltAlsText);
  if hatPOP3Client.fehler then
    hatZeilenbereich.haengeAn(hatPOP3Client.fehlermeldung)
  else begin
    hatKnopfHolen.aktiviere;
    hatKnopfAbmelden.aktiviere;
    hatKnopfAnmelden.deaktiviere;
    hatEtikettAnzahl.setzeInhalt(hatPOP3Client.anzahlNachrichten);
  end
end;

procedure TMailForm.hatKnopfHolenGeklickt(Sender: TObject);
begin
  hatZeilenbereich.setzeInhalt( hatPOP3Client.gibNachricht(hatTextfeldNr.inhaltAlsGanzeZahl) );
  if hatPOP3Client.fehler then begin
    hatZeilenbereich.fuegeEin(hatPOP3Client.fehlermeldung+CRLF+CRLF,1);
  end;
end;

procedure TMailForm.hatKnopfAbmeldenGeklickt(Sender: TObject);
begin
  hatPOP3Client.abmelden;
  hatKnopfHolen.deaktiviere;
  hatKnopfAbmelden.deaktiviere;
  hatKnopfAnmelden.aktiviere;
  hatEtikettAnzahl.setzeInhalt('-');
end;

procedure TMailForm.hatKnopfBeendenGeklickt(Sender: TObject);
begin
  if hatPOP3Client.angemeldet then
    hatPOP3Client.abmelden;
  hatPOP3Client.gibFrei;
  self.close
end;

end.
