{*******************************************************************************
 *  Server     : Netzwerkuntersttzung fr Stifte und Muse                    *
 *               Version 2.0 vom 27.02.2006                                    *
 *               Joachim Deckers, Mariengymnasium Arnsberg                     *
 *               Ursprngliche Fassung: Klaus Dingemann                        *
 *               eMail: sum-delphi@deckers.name                                *
 *******************************************************************************
 * Bitte teilen Sie den Entwicklern Ihre Verbesserungsvorschlge mit oder      *
 * weisen Sie sie auf Fehler (und ggf. deren Berichtigung) hin.                *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************
 * nderungen                                                                  *
 * Version 2.0:                                                                *
 *   - Alle Ereignisbearbeitungsmethoden sind nun auch mit Portnummern imple-  *
 *     mentiert.                                                               *
 *******************************************************************************}

unit mServer;

INTERFACE
uses ScktComp, Forms, Windows, Messages, SysUtils, Classes, Graphics, Controls,
      Dialogs, StDCtrls, mProtokollfenster,mSuM,mTextwerkzeug, Winsock, mSerververbindung, mListe;
const
     ZEILENENDE=#13#10;

type
  Server = class
              private
              hatServerSocket:TServerSocket;
              zMitProtokollieren:Wahrheitswert;
              zPort:GanzeZahl;
              hatTextwerkzeug:Textwerkzeug;
              hatkontrollFenster:TKontrollFenster;
              protected
              procedure ServerSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
              procedure ServerSocketGetSocket(Sender: TObject; Socket: TSocket; var ClientSocket: TServerClientWinSocket);
              procedure ServerSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
              procedure ServerSocketClientWrite(Sender: TObject; Socket: TCustomWinSocket);
              procedure ServerSocketClientError(Sender: TObject;Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: GanzeZahl);
              procedure ServerSocketDisconnect(Sender: TObject; Socket: TCustomWinSocket);
              public
              constructor init(pPortNr:GanzeZahl; pMitProtokollieren:Wahrheitswert);
              procedure sendeAnAlle(pNachricht:Zeichenkette);
              procedure sendeAnEinen(pClientIP:Zeichenkette; pNachricht:Zeichenkette);overload;
              procedure melde(pMeldung:Zeichenkette);
              procedure beendeVerbindung(pCLientIP:Zeichenkette);overload;
              function port:integer;
              function clientListe:Liste;
              function serverVerbindungVonIP(pClientIP:Zeichenkette):ServerVerbindung;overload;
              function zahlDerVerbindungen:GanzeZahl;
              function mitProtokoll:Wahrheitswert;

              procedure sendeAnEinen(pClientIP:Zeichenkette; pClientPort: GanzeZahl; pNachricht:Zeichenkette);overload;
              procedure beendeVerbindung(pCLientIP:Zeichenkette; pClientPort: GanzeZahl);overload;
              function  serverVerbindungVonIP(pClientIP:Zeichenkette; pClientPort: GanzeZahl):ServerVerbindung;overload;


              procedure bearbeiteVerbindungsaufbau(pClientIP:Zeichenkette);overload;virtual;
              procedure bearbeiteNachricht(pSender,pNachricht:Zeichenkette); overload;virtual;
              procedure bearbeiteVerbindungsverlust(pClientIP:Zeichenkette);overload;virtual;
              procedure bearbeiteVerbindungsende(pClientIP:Zeichenkette);overload;virtual;

              procedure bearbeiteVerbindungsaufbau(pClientIP:Zeichenkette; pClientPort: GanzeZahl);overload;virtual;
              procedure bearbeiteNachricht(pSender: Zeichenkette; pClientPort: GanzeZahl; pNachricht:Zeichenkette); overload;virtual;
              procedure bearbeiteVerbindungsverlust(pClientIP:Zeichenkette; pClientPort: GanzeZahl);overload;virtual;
              procedure bearbeiteVerbindungsende(pClientIP:Zeichenkette; pClientPort: GanzeZahl);overload;virtual;

              procedure setzeInhalt(pClientIP:Zeichenkette; pInhalt:TObject);
              function inhalt(pClientIP:Zeichenkette):TObject;
              function hatInhalt(pClientIP:Zeichenkette):boolean;
              destructor gibFrei;virtual;
            end;


IMPLEMENTATION

  constructor Server.init(pPortNr:GanzeZahl;pMitProtokollieren:Wahrheitswert);
  begin
    zMitProtokollieren:=pMitProtokollieren;
    if zMitProtokollieren then begin
       hatKontrollfenster:=TKontrollfenster.create(Application);
       hatKontrollfenster.show;
    end;
    zPort:=pPortNr;
    hatServerSocket:=TServerSocket.Create(Application);
    hatServerSocket.Port:=zPort;
    hatServerSocket.ServerType:=stNonBlocking;
    hatServerSocket.OnClientConnect:=ServerSocketConnect;
    hatServerSocket.OnGetSocket:=ServerSocketGetSocket;
    hatServerSocket.OnClientRead:=ServerSocketClientRead;
    hatServerSocket.OnClientError:=ServerSocketClientError;
    hatServerSocket.OnClientDisconnect:=ServerSocketDisconnect;
    hatServerSocket.Open;
    self.melde('Server erwartet Verbindungen auf Port '+intToStr(zPort));
    hatTextwerkzeug:=Textwerkzeug.init;
  end;

  function Server.zahlDerVerbindungen:GanzeZahl;
  begin
    result:=hatServerSocket.socket.ActiveConnections;
  end;

  function Server.serverVerbindungVonIP(pClientIP:Zeichenkette):Serververbindung;
  var
    lVerbindungsnummer, lZaehler:GanzeZahl;
  begin
    lVerbindungsnummer:=-1;
    lZaehler:=0;
    while (lVerbindungsNummer<0) and (lZaehler<hatServerSocket.Socket.activeConnections) do
      if hatServerSocket.socket.connections[lZaehler].remoteAddress=pClientIP then
        lVerbindungsNummer:=lZaehler
      else
        inc(lZaehler);
    if lVerbindungsnummer>=0 then
      result:=Serververbindung(hatServerSocket.socket.connections[lVerbindungsnummer])
    else
       result:=nil;
  end;

  function Server.serverVerbindungVonIP(pClientIP: Zeichenkette; pClientPort: GanzeZahl): ServerVerbindung;
  var lVerbindungsnummer, lZaehler:GanzeZahl;
  begin
    lVerbindungsnummer:=-1;
    lZaehler:=0;
    while (lVerbindungsNummer<0) and (lZaehler<hatServerSocket.Socket.activeConnections) do
      if (hatServerSocket.socket.connections[lZaehler].remoteAddress=pClientIP) and
         (hatServerSocket.socket.connections[lZaehler].remotePort=pClientPort) then
        lVerbindungsNummer:=lZaehler
      else
        inc(lZaehler);
    if lVerbindungsnummer>=0 then
      result:=Serververbindung(hatServerSocket.socket.connections[lVerbindungsnummer])
    else
       result:=nil;
  end;
  
  procedure Server.ServerSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
  begin
       bearbeiteVerbindungsaufbau(Socket.RemoteAddress);
       bearbeiteVerbindungsaufbau(Socket.RemoteAddress, Socket.RemotePort);
  end;

  procedure Server.ServerSocketGetSocket(Sender: TObject; Socket: TSocket; var ClientSocket: TServerClientWinSocket);
   begin
    ClientSocket:=Serververbindung.create(Socket,hatServerSocket.socket);
  end;

  procedure Server.ServerSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
  var
    lNachricht,lEineNachricht:Zeichenkette;
    lZaehler:GanzeZahl;
  begin
    lNachricht:=Socket.receiveText;
    hatTextwerkzeug.setzeTrennungszeichen(ZEILENENDE);
    lZaehler:=1;
    repeat
       lEineNachricht:=hatTextwerkzeug.wortAn(lNachricht,lZaehler);
       if lEineNachricht<>'' then begin
         melde('Server liest: '+lEineNachricht);
         bearbeiteNachricht(Socket.RemoteAddress,lEineNachricht);
         bearbeiteNachricht(Socket.RemoteAddress,Socket.RemotePort,lEineNachricht);
         inc(lZaehler)
       end
     until lEineNachricht='';
  end;

  procedure Server.ServerSocketClientWrite(Sender: TObject; Socket: TCustomWinSocket);
  begin
  end;

  procedure Server.ServerSocketClientError(Sender: TObject;Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
                                    var ErrorCode: GanzeZahl);
  var
    lFehler:Zeichenkette;
  begin
    case ErrorEvent of
    eeGeneral:lFehler:='Unbekannter Fehler';
    eeSend:lFehler:='Der Server konnte nicht senden';
    eeReceive:lFehler:='Der Server konnte keine Nachricht empfangen';
    eeConnect:lFehler:='Der Server konnte keine Verbindung aufbauen';
    eeDisconnect:lFehler:='Die Verbindung konnte nicht geschlossen werden.';
    eeAccept:lFehler:='Der Server konnte keine Verbindung aufbauen';
    end;
    self.melde(lFehler);
    if ErrorEvent<>eeDisconnect then //jd
      Socket.close;
    if {(ErrorEvent=eeSend) or } (ErrorEvent=eeDisconnect) then
    begin
      self.BearbeiteVerbindungsverlust(Socket.RemoteAddress);
      self.BearbeiteVerbindungsverlust(Socket.RemoteAddress, Socket.RemotePort);
    end;
    ErrorCode:=0; // jd: verhindert Asynchronen Socket-Fehler 10053
  end;

  procedure Server.ServerSocketDisconnect(Sender: TObject; Socket: TCustomWinSocket);
  begin
    // self.bearbeiteVerbindungsende(Socket.RemoteAddress); ...fhrt zu Endlosschleifen 
  end;

  procedure Server.sendeAnEinen(pClientIP:Zeichenkette; pNachricht:Zeichenkette);
  var
    lVerbindung:TCustomWinSocket;
  begin
    lVerbindung:=self.serverVerbindungVonIP(pCLientIP);
    if (lVerbindung<>nil) then begin
        lVerbindung.sendText(pNachricht+ZEILENENDE);
        self.melde('Server sendet Nachricht: "'+pNachricht+'" an Client: '+pCLientIP) ;
    end else
          self.melde('Fehler beim Senden: '+pClientIP + ' nicht vorhanden');
  end;

  procedure Server.sendeAnEinen(pClientIP: Zeichenkette;pClientPort: GanzeZahl; pNachricht: Zeichenkette);
  var lVerbindung:TCustomWinSocket;
  begin
    lVerbindung:=self.serverVerbindungVonIP(pCLientIP, pClientPort);
    if (lVerbindung<>nil) then begin
        lVerbindung.sendText(pNachricht+ZEILENENDE);
        self.melde('Server sendet Nachricht: "'+pNachricht+'" an Client: '+pCLientIP+' Port: '+IntToStr(pClientPort)) ;
    end else
          self.melde('Fehler beim Senden: '+pClientIP + ':' + IntToStr(pClientPort) + ' nicht vorhanden');

  end;
  
  procedure Server.sendeAnAlle(pNachricht:Zeichenkette);
  var
    lVerbindungenZaehler:GanzeZahl;
    lVerbindung:TCustomWinSocket;
  begin
       for lVerbindungenZaehler:=0 to hatServerSocket.Socket.ActiveConnections-1 do begin
        lVerbindung:=hatServerSocket.socket.connections[lVerbindungenZaehler];
        lVerbindung.sendText(pNachricht+ZEILENENDE);
        self.melde('Server sendet Nachricht: "'+pNachricht+'" an Client: '+hatServerSocket.socket.connections[lVerbindungenZaehler].remoteAddress);
       end;
  end;

  function Server.clientListe:Liste;
  var
   lVerbindungenZaehler:ganzeZahl;
   lClientListe:Liste;
   lVerbindung:Serververbindung;
   lInhalt:TObject;
  begin
    lClientListe:=Liste.init;
    for lVerbindungenZaehler:=0 to hatServerSocket.Socket.ActiveConnections-1 do begin
      lVerbindung:=Serververbindung(hatServerSocket.socket.connections[lVerbindungenZaehler]);
      lInhalt:=lVerbindung.inhalt;
      if lInhalt<>nil then
        lClientListe.haengeAn(lInhalt);
    end;
    result:=lClientListe;
   end;

   procedure Server.setzeInhalt(pClientIP:Zeichenkette; pInhalt:TObject);
  var
    lVerbindung:Serververbindung;
  begin
    lVerbindung:=self.serverVerbindungVonIP(pCLientIP);
    lVerbindung.setzeInhalt(pInhalt);
  end;

  function Server.inhalt(pClientIP:Zeichenkette):TObject;
  var
    lVerbindung:Serververbindung;
  begin
    lVerbindung:=self.serverVerbindungVonIP(pCLientIP);
    result:=lVerbindung.inhalt;
  end;

  function Server.hatInhalt(pClientIP:Zeichenkette):boolean;
  var
    lVerbindung:Serververbindung;
  begin
    lVerbindung:=self.serverVerbindungVonIP(pCLientIP);
    result:=lVerbindung.hatInhalt;
  end;


  function Server.mitProtokoll:Wahrheitswert;
  begin
    result:=zMitProtokollieren;
  end;

  procedure Server.bearbeiteNachricht(pSender,pNachricht:Zeichenkette);
  begin
  end;

  procedure Server.bearbeiteVerbindungsaufbau(pClientIP:Zeichenkette);
  begin
  end;

  procedure Server.bearbeiteVerbindungsverlust(pClientIP:Zeichenkette);
  begin
  end;

  procedure Server.bearbeiteVerbindungsende(pClientIP:Zeichenkette);
  begin
  end;

  procedure Server.bearbeiteNachricht(pSender: Zeichenkette;pClientPort: GanzeZahl; pNachricht: Zeichenkette);
  begin
  end;

  procedure Server.bearbeiteVerbindungsaufbau(pClientIP: Zeichenkette; pClientPort: GanzeZahl);
  begin
  end;

  procedure Server.bearbeiteVerbindungsende(pClientIP: Zeichenkette; pClientPort: GanzeZahl);
  begin
  end;

  procedure Server.bearbeiteVerbindungsverlust(pClientIP: Zeichenkette; pClientPort: GanzeZahl);
  begin
  end;

  procedure Server.beendeVerbindung(pCLientIP:Zeichenkette);
  var
    lClientVerbindung:TCustomWinSocket;
  begin
    lClientVerbindung:=self.serverVerbindungVonIP(pClientIP);
    if lClientVerbindung<>nil then begin
      self.melde('Aktive Verbindungen '+intToStr(hatServerSocket.socket.activeConnections));
      self.bearbeiteVerbindungsende(pClientIP);
      lClientVerbindung.Close;
      lClientVerbindung.free;
      self.melde('Aktive Verbindungen '+intToStr(hatServerSocket.socket.activeConnections));
    end else
          self.melde('Fehler beim Schlieen der Verbindung: '+pCLientIP+' nicht vorhanden');
  end;

  procedure Server.beendeVerbindung(pCLientIP: Zeichenkette; pClientPort: GanzeZahl);
  var
    lClientVerbindung:TCustomWinSocket;
  begin
    lClientVerbindung:=self.serverVerbindungVonIP(pClientIP,pClientPort);
    if lClientVerbindung<>nil then begin
      self.melde('Aktive Verbindungen '+intToStr(hatServerSocket.socket.activeConnections));
      self.bearbeiteVerbindungsende(pClientIP,pClientPort);
      lClientVerbindung.Close;
      lClientVerbindung.free;
      self.melde('Aktive Verbindungen '+intToStr(hatServerSocket.socket.activeConnections));
    end else
          self.melde('Fehler beim Schlieen der Verbindung: '+pCLientIP+':' +IntToStr(pClientPort)+' nicht vorhanden');
  end;

  function Server.port:integer;
  begin
    result:=hatServerSocket.socket.localPort;
  end;

  procedure Server.melde(pMeldung:Zeichenkette);
  begin
    if zMitProtokollieren then
      hatKontrollfenster.Memo1.Lines.Add(pMeldung);
  end;

  destructor Server.gibFrei;
  begin
    hatServerSocket.Close;
    hatServerSocket.destroy;
  end;

end.
